using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using System.Diagnostics;
 
namespace WordInOutlook
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("40964CDC-C9C4-4C82-A239-4FD51A9780CF"), ProgId("WordInOutlook.AddinModule"), RunInstaller(true)]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule(System.ComponentModel.IContainer container)
        {
            // This call is required by the Component Designer
            container.Add(this);
            InitializeComponent();
 
            // TODO: Add any initialization after the InitializeComponent call
        }
		private AddinExpress.MSO.ADXCommandBar adxCommandBar1;
		private AddinExpress.MSO.ADXCommandBarButton adxCommandBarButton1;
		private AddinExpress.MSO.ADXOlInspectorCommandBar adxOlInspectorCommandBar1;
		private AddinExpress.MSO.ADXCommandBarButton adxCommandBarButton2;
		private AddinExpress.MSO.ADXCommandBar adxCommandBar2;
		private AddinExpress.MSO.ADXOutlookAppEvents adxOutlookEvents;
		private AddinExpress.MSO.ADXWordAppEvents adxWordEvents;
 
        public AddinModule()
        {
            InitializeComponent();
        }
 
        // Add-in Module Implementation
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
			this.components = new System.ComponentModel.Container();
			this.adxWordEvents = new AddinExpress.MSO.ADXWordAppEvents(this.components);
			this.adxCommandBar1 = new AddinExpress.MSO.ADXCommandBar(this.components);
			this.adxCommandBarButton1 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.adxOlInspectorCommandBar1 = new AddinExpress.MSO.ADXOlInspectorCommandBar(this.components);
			this.adxCommandBarButton2 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.adxCommandBar2 = new AddinExpress.MSO.ADXCommandBar(this.components);
			this.adxOutlookEvents = new AddinExpress.MSO.ADXOutlookAppEvents(this.components);
			// 
			// adxWordEvents
			// 
			this.adxWordEvents.WindowActivate += new AddinExpress.MSO.ADXHostWindow_EventHandler(this.adxWordEvents_WindowActivate);
			this.adxWordEvents.Startup += new System.EventHandler(this.adxWordEvents_Startup);
			// 
			// adxCommandBar1
			// 
			this.adxCommandBar1.CommandBarName = "Word Bar";
			this.adxCommandBar1.CommandBarTag = "06e30d11-c592-45cc-9fe9-f04e0c7f8d55";
			this.adxCommandBar1.Controls.Add(this.adxCommandBarButton1);
			this.adxCommandBar1.Position = AddinExpress.MSO.ADXMsoBarPosition.adxMsoBarTop;
			this.adxCommandBar1.UpdateCounter = 7;
			// 
			// adxCommandBarButton1
			// 
			this.adxCommandBarButton1.Caption = "Word Button";
			this.adxCommandBarButton1.ControlTag = "87ccaefc-786a-4a75-9bd8-ecb0c655af58";
			this.adxCommandBarButton1.ImageTransparentColor = System.Drawing.Color.Transparent;
			this.adxCommandBarButton1.UpdateCounter = 2;
			this.adxCommandBarButton1.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.adxCommandBarButton1_Click);
			// 
			// adxOlInspectorCommandBar1
			// 
			this.adxOlInspectorCommandBar1.CommandBarName = "Standard";
			this.adxOlInspectorCommandBar1.CommandBarTag = "eadb0836-dd81-4687-9087-7bd7baa5adbb";
			this.adxOlInspectorCommandBar1.Controls.Add(this.adxCommandBarButton2);
			this.adxOlInspectorCommandBar1.Temporary = true;
			this.adxOlInspectorCommandBar1.UpdateCounter = 4;
			// 
			// adxCommandBarButton2
			// 
			this.adxCommandBarButton2.Caption = "My Standard Button";
			this.adxCommandBarButton2.ControlTag = "eb2e2c93-b035-48de-85fa-37047fd4be9b";
			this.adxCommandBarButton2.ImageTransparentColor = System.Drawing.Color.Transparent;
			this.adxCommandBarButton2.Temporary = true;
			this.adxCommandBarButton2.UpdateCounter = 2;
			this.adxCommandBarButton2.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.adxCommandBarButton2_Click);
			// 
			// adxCommandBar2
			// 
			this.adxCommandBar2.CommandBarName = "Standard";
			this.adxCommandBar2.CommandBarTag = "82dc6d5a-4164-42cc-a61f-5a80b6589533";
			this.adxCommandBar2.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaWord;
			this.adxCommandBar2.UpdateCounter = 5;
			// 
			// adxOutlookEvents
			// 
			this.adxOutlookEvents.InspectorActivate += new AddinExpress.MSO.ADXOlInspector_EventHandler(this.adxOutlookEvents_InspectorActivate);
			// 
			// AddinModule
			// 
			this.AddinName = "Word In Outlook";
			this.SupportedApps = ((AddinExpress.MSO.ADXOfficeHostApp)((AddinExpress.MSO.ADXOfficeHostApp.ohaWord | AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook)));
			this.BeforeUninstallControls += new AddinExpress.MSO.ADXUninstallControls_EventHandler(this.AddinModule_BeforeUninstallControls);
			this.AddinStartupComplete += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinStartupComplete);

		}
        #endregion
 
        #region ADX automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

		
		private void SetCommandBarState()
		{
			if (Process.GetCurrentProcess().MainWindowTitle.IndexOf("Word") == -1)
			{
				adxCommandBar1.Visible = false;
				adxCommandBarButton2.Visible = true;
			}
			else
			{
				adxCommandBar1.Visible = true;
				Microsoft.Office.Core.CommandBarControl control = FindControlObj(adxCommandBar2.CommandBarObj, 
					Microsoft.Office.Core.MsoControlType.msoControlButton, adxCommandBarButton2.ControlTag) as Microsoft.Office.Core.CommandBarControl;
				if (control != null)
				{
					control.Visible = false;
				}
			}
		}

		private void adxWordEvents_WindowActivate(object sender, object hostObj, object window)
		{
			SetCommandBarState();
		}

		private void adxCommandBarButton1_Click(object sender)
		{
			MessageBox.Show("I am here!");
		}

		private void AddinModule_AddinStartupComplete(object sender, System.EventArgs e)
		{
			if (HostType == AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook)
				adxCommandBar1.Enabled = false;
		}

		private void adxWordEvents_Startup(object sender, System.EventArgs e)
		{
			SetCommandBarState();
		}

		private void adxOutlookEvents_InspectorActivate(object sender, object inspector, string folderName)
		{
			adxCommandBarButton2.Visible = true;
		}

		private void adxCommandBarButton2_Click(object sender)
		{
			MessageBox.Show("My Standard Outlook button");
		}

		private void AddinModule_BeforeUninstallControls(object sender, AddinExpress.MSO.ADXOfficeHostApp hostApp, object hostAppObj)
		{
			if (hostApp == AddinExpress.MSO.ADXOfficeHostApp.ohaWord)
			{
				Microsoft.Office.Core.CommandBar cmb = 
					FindCommandBarObj("Standard") as Microsoft.Office.Core.CommandBar;
				if (cmb != null)
				{
					Microsoft.Office.Core.CommandBarControl control = FindControlObj(cmb, 
						Microsoft.Office.Core.MsoControlType.msoControlButton, adxCommandBarButton2.ControlTag) as Microsoft.Office.Core.CommandBarControl;
					if (control != null)
					{
						control.Delete(false);
					}
				}
			}
		}

    }
}

